"""
RingCentral Connect Platform API Explorer v1.0.40

This is an interactive API explorer for the RingCentral Connect Platform. To use this service,
you will need to have a developer account.

## Links

* <a
href="https://netstorage.ringcentral.com/dpw/api-reference/rc-platform.yml?v=20200817050758"
target="_blank">RingCentral API Spec</a><span>&nbsp;&nbsp;(OpenAPI fka Swagger
format)&nbsp;&nbsp;&nbsp;&nbsp;</span><a href="https://github.com/OAI/OpenAPI-Specification"
target="_blank">Learn more about OpenAPI</a>

Generated by Python OpenAPI Parser v0.2.1
"""

from collections import namedtuple

from .client import *

__title__ = 'ringcentral-async-client'
__author__ = 'Peter Zaitcev / USSX-Hares'
__license__ = 'MIT License'
__copyright__ = 'Copyright 2020 Peter Zaitcev'
__version__ = '1.0.1'

VersionInfo = namedtuple('VersionInfo', 'major minor micro releaselevel serial')
version_info = VersionInfo(*__version__.split('.'), releaselevel='alpha', serial=0)

__all__ = \
[
    'version_info',
    '__title__',
    '__author__',
    '__license__',
    '__copyright__',
    '__version__',
]
__pdoc__ = { }
__pdoc_extras__ = [ ]

_submodules = \
[
    client,
]

for _submodule in _submodules:
    _submodule_name = _submodule.__name__.partition(f'{__name__}.')[-1]
    __all__.extend(_submodule.__all__)
    __pdoc__[_submodule_name] = True
    _submodule.__pdoc__ = getattr(_submodule, '__pdoc__', dict())
    _extras = getattr(_submodule, '__pdoc_extras__', list())
    for _element in _submodule.__all__:
        __pdoc__[_element] = _element in _extras

